"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Icon = _interopRequireDefault(require("./Icon"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
// eslint-disable-next-line react/prop-types
const Wrapper = _ref => {
  let {
    condition,
    children
  } = _ref;
  return condition ? /*#__PURE__*/_react.default.createElement("div", {
    className: "card-stacked"
  }, children) : /*#__PURE__*/_react.default.createElement(_react.Fragment, null, children);
};
const Card = _ref2 => {
  let {
    title,
    header,
    className,
    textClassName,
    actions,
    reveal,
    children,
    horizontal,
    closeIcon,
    revealIcon,
    ...other
  } = _ref2;
  const classes = {
    card: true,
    horizontal: horizontal
  };
  return /*#__PURE__*/_react.default.createElement("div", _extends({}, other, {
    className: (0, _classnames.default)(className, classes)
  }), header, /*#__PURE__*/_react.default.createElement(Wrapper, {
    condition: horizontal
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)('card-content', textClassName)
  }, title && /*#__PURE__*/_react.default.createElement("span", {
    className: (0, _classnames.default)('card-title', {
      activator: reveal
    })
  }, title, reveal && /*#__PURE__*/(0, _react.cloneElement)(revealIcon, {
    right: true
  })), /*#__PURE__*/_react.default.createElement("div", null, children)), /*#__PURE__*/_react.default.createElement("div", {
    className: "card-reveal"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "card-title"
  }, title, /*#__PURE__*/(0, _react.cloneElement)(closeIcon, {
    right: true
  })), reveal), actions && /*#__PURE__*/_react.default.createElement("div", {
    className: "card-action"
  }, actions)));
};
Card.propTypes = {
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  title: _propTypes.default.string,
  textClassName: _propTypes.default.string,
  reveal: _propTypes.default.element,
  header: _propTypes.default.element,
  // The buttons to be displayed at the action area
  actions: _propTypes.default.arrayOf(_propTypes.default.element),
  horizontal: _propTypes.default.bool,
  /**
   * @default <Icon>close</Icon>
   */
  closeIcon: _propTypes.default.node,
  /**
   * @default <Icon>more_vert</Icon>
   */
  revealIcon: _propTypes.default.node
};
Card.defaultProps = {
  closeIcon: /*#__PURE__*/_react.default.createElement(_Icon.default, null, "close"),
  revealIcon: /*#__PURE__*/_react.default.createElement(_Icon.default, null, "more_vert")
};
var _default = exports.default = Card;