"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _constants = _interopRequireDefault(require("./constants"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const CardTitle = _ref => {
  let {
    className,
    image,
    reveal,
    waves,
    children,
    ...props
  } = _ref;
  const classes = (0, _classnames.default)(className, {
    'card-image': true,
    'waves-effect': waves,
    'waves-block': waves,
    [`waves-${waves}`]: waves
  });
  return /*#__PURE__*/_react.default.createElement("div", _extends({
    className: (0, _classnames.default)(classes)
  }, props), /*#__PURE__*/_react.default.createElement("img", {
    className: (0, _classnames.default)({
      activator: reveal
    }),
    src: image
  }), /*#__PURE__*/_react.default.createElement("span", {
    className: (0, _classnames.default)('card-title')
  }, children));
};
CardTitle.propTypes = {
  children: _propTypes.default.node,
  /**
   * Whether the image serves as activator for the reveal
   */
  reveal: _propTypes.default.bool,
  /**
   * the waves effect
   */
  waves: _propTypes.default.oneOf(_constants.default.WAVES),
  /**
   * The path to the image
   */
  image: _propTypes.default.string.isRequired,
  /**
   * custom classname
   */
  className: _propTypes.default.string
};
var _default = exports.default = CardTitle;