"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _idgen = _interopRequireDefault(require("./idgen"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const Carousel = _ref => {
  let {
    children,
    className,
    carouselId,
    fixedItem,
    images,
    centerImages,
    options
  } = _ref;
  const carouselRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(() => {
    const instance = M.Carousel.init(carouselRef.current, options);
    return () => instance.destroy();
  }, [options, children, images]);
  const elemsToRender = children || images || [];
  const classes = (0, _classnames.default)('carousel', {
    'carousel-slider': options.fullWidth
  }, className);
  return /*#__PURE__*/_react.default.createElement("div", {
    id: carouselId,
    ref: carouselRef,
    className: classes
  }, Boolean(fixedItem) && /*#__PURE__*/_react.default.createElement("div", {
    className: "carousel-fixed-item center"
  }, fixedItem), _react.default.Children.map(elemsToRender, child => {
    const classes = (0, _classnames.default)('carousel-item', {
      'valign-wrapper': centerImages
    });
    if (typeof child === 'string') {
      return /*#__PURE__*/_react.default.createElement("a", {
        className: classes
      }, /*#__PURE__*/_react.default.createElement("img", {
        src: child,
        alt: child
      }));
    }
    return /*#__PURE__*/_react.default.cloneElement(child, {
      className: (0, _classnames.default)(classes, child.props.className)
    });
  }));
};
Carousel.propTypes = {
  /**
   * Children to render as carousel elements
   */
  children: _propTypes.default.any,
  /**
   * Array of image url's
   */
  images: _propTypes.default.arrayOf(_propTypes.default.string),
  /**
   * Makes the images centered inside the carousel using '.valign-wrapper' CSS helper
   */
  centerImages: _propTypes.default.bool,
  /**
   * Fixed element on slider
   */
  fixedItem: _propTypes.default.node,
  /**
   * Additional classNames for carousel wrapper
   */
  className: _propTypes.default.string,
  /**
   * Carousel ID for jQuery manipulating
   * @default idgen()
   */
  carouselId: _propTypes.default.string,
  /**
   * Carousel initialization options
   * <a href="http://materializecss.com/carousel.html">http://materializecss.com/carousel.html</a>
   */
  options: _propTypes.default.shape({
    /**
     * Transition duration in milliseconds. (Default: 200)
     */
    duration: _propTypes.default.number,
    /**
     * Perspective zoom. If 0, all items are the same size. (Default: -100)
     */
    dist: _propTypes.default.number,
    /**
     * Set the spacing of the center item. (Default: 0)
     */
    shift: _propTypes.default.number,
    /**
     * Set the padding between non center items. (Default: 0)
     */
    padding: _propTypes.default.number,
    /**
     * Set the number of visible items. (Default: 5)
     */
    numVisible: _propTypes.default.number,
    /**
     * Make the carousel a full width slider. (Default: false)
     */
    fullWidth: _propTypes.default.bool,
    /**
     * Set to true to show indicators. (Default: false)
     */
    indicators: _propTypes.default.bool,
    /**
     * Don't wrap around and cycle through items. (Default: false)
     */
    noWrap: _propTypes.default.bool,
    /**
     * Callback for when a new slide is cycled to. (Default: null)
     */
    onCycleTo: _propTypes.default.func
  })
};
Carousel.defaultProps = {
  get carouselId() {
    return `Carousel-${(0, _idgen.default)()}`;
  },
  options: {
    duration: 200,
    dist: -100,
    shift: 0,
    padding: 0,
    numVisible: 5,
    fullWidth: false,
    indicators: false,
    noWrap: false,
    onCycleTo: null
  }
};
var _default = exports.default = Carousel;