"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _idgen = _interopRequireDefault(require("./idgen"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const Checkbox = _ref => {
  let {
    id,
    className,
    indeterminate,
    filledIn,
    label,
    onChange,
    ...props
  } = _ref;
  const [checked, setChecked] = (0, _react.useState)(props.checked);
  const _input = (0, _react.useRef)(null);
  (0, _react.useEffect)(() => {
    if (_input.current) {
      _input.current.indeterminate = indeterminate;
      _input.current.checked = false;
      setChecked(false);
    }
  }, [indeterminate]);
  (0, _react.useEffect)(() => {
    setChecked(props.checked);
    _input.current.checked = props.checked;
  }, [props.checked]);
  return /*#__PURE__*/_react.default.createElement("label", {
    htmlFor: id
  }, /*#__PURE__*/_react.default.createElement("input", _extends({}, props, {
    id: id,
    className: (0, _classnames.default)({
      'filled-in': filledIn
    }, className),
    type: "checkbox",
    ref: _input,
    checked: checked,
    onChange: e => {
      setChecked(prevChecked => !prevChecked);
      onChange && onChange(e);
    }
  })), /*#__PURE__*/_react.default.createElement("span", null, label));
};
Checkbox.propTypes = {
  className: _propTypes.default.string,
  /**
   * checkbox value
   */
  value: _propTypes.default.string.isRequired,
  /**
   * filled-in styled checkbox
   */
  filledIn: _propTypes.default.bool,
  /**
   * label next to checkbox
   */
  label: _propTypes.default.string.isRequired,
  /**
   * Indeterminate Style
   */
  indeterminate: _propTypes.default.bool,
  /**
   * onChange callback
   */
  onChange: _propTypes.default.func,
  /**
   * override id
   * @default idgen()
   */
  id: _propTypes.default.string,
  /**
   * disabled input
   */
  disabled: _propTypes.default.bool,
  /**
   * A Boolean attribute indicating whether or not this checkbox is checked
   */
  checked: _propTypes.default.bool
};
Checkbox.defaultProps = {
  get id() {
    return `Checkbox_${(0, _idgen.default)()}`;
  }
};
var _default = exports.default = Checkbox;