"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _idgen = _interopRequireDefault(require("./idgen"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const MediaBox = _ref => {
  let {
    id,
    options,
    children,
    className,
    caption,
    ...props
  } = _ref;
  const mediaBoxRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(() => {
    const instance = M.Materialbox.init(mediaBoxRef.current, options);
    return () => {
      if (instance) {
        instance.destroy();
      }
    };
  }, [id, options, children]);
  return /*#__PURE__*/_react.default.cloneElement(children, {
    id: id,
    ref: mediaBoxRef,
    className: (0, _classnames.default)('materialboxed', className),
    'data-caption': caption,
    ...props
  });
};
MediaBox.propTypes = {
  children: _propTypes.default.node.isRequired,
  /**
   * override id
   * @default idgen()
   */
  id: _propTypes.default.string,
  className: _propTypes.default.string,
  /**
   * The caption shown below the image when opened
   */
  caption: _propTypes.default.string,
  options: _propTypes.default.shape({
    /**
     * Transition in duration in milliseconds.
     */
    inDuration: _propTypes.default.number,
    /**
     * Transition out duration in milliseconds.
     */
    outDuration: _propTypes.default.number,
    /**
     * Callback function called before materialbox is opened.
     */
    onOpenStart: _propTypes.default.func,
    /**
     * Callback function called after materialbox is opened.
     */
    onOpenEnd: _propTypes.default.func,
    /**
     * Callback function called before materialbox is closed.
     */
    onCloseStart: _propTypes.default.func,
    /**
     * Callback function called after materialbox is closed.
     */
    onCloseEnd: _propTypes.default.func
  })
};
MediaBox.defaultProps = {
  get id() {
    return `MediaBox_${(0, _idgen.default)()}`;
  },
  options: {
    inDuration: 275,
    outDuration: 200,
    onOpenStart: null,
    onOpenEnd: null,
    onCloseStart: null,
    onCloseEnd: null
  }
};
var _default = exports.default = MediaBox;