"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const RadioGroup = _ref => {
  let {
    onChange,
    withGap,
    disabled,
    name,
    radioClassNames,
    value,
    options
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, options.map((radioItem, idx) => /*#__PURE__*/_react.default.createElement("label", {
    className: radioClassNames,
    htmlFor: `radio${idx}`,
    key: `radio${idx}`
  }, /*#__PURE__*/_react.default.createElement("input", {
    id: `radio${idx}`,
    value: radioItem.value,
    type: "radio",
    checked: radioItem.value === value,
    name: name,
    onChange: onChange,
    disabled: disabled,
    className: (0, _classnames.default)({
      'with-gap': withGap
    })
  }), /*#__PURE__*/_react.default.createElement("span", null, radioItem.label))));
};
RadioGroup.propTypes = {
  options: _propTypes.default.arrayOf(_propTypes.default.shape({
    label: _propTypes.default.string.isRequired,
    value: _propTypes.default.string.isRequired
  })).isRequired,
  /**
   * predefined checked value
   */
  value: _propTypes.default.string,
  /**
   * radio group name
   */
  name: _propTypes.default.string,
  /**
   * with-gap styled checkbox
   */
  withGap: _propTypes.default.bool,
  /**
   * onChange callback
   */
  onChange: _propTypes.default.func,
  /**
   * disabled input
   */
  disabled: _propTypes.default.bool,
  /**
   * classnames passed to label wrapper
   */
  radioClassNames: _propTypes.default.string
};
var _default = exports.default = RadioGroup;